Index: /trunk/src/gmakenew/config.h.darwin
===================================================================
--- /trunk/src/gmakenew/config.h.darwin	(revision 940)
+++ /trunk/src/gmakenew/config.h.darwin	(revision 941)
@@ -1,3 +1,3 @@
-/* config.h.  Generated by configure.  */
+/* config.h.  Generated from config.h.in by configure.  */
 /* config.h.in.  Generated from configure.in by autoheader.  */
 
@@ -19,8 +19,4 @@
 /* #undef DGUX */
 
-/* Define to 1 if translation of program messages to the user's native
-   language is requested. */
-/* #undef ENABLE_NLS */
-
 /* Use high resolution file timestamps if nonzero. */
 #define FILE_TIMESTAMP_HI_RES 0
@@ -37,5 +33,5 @@
 #define HAVE_ALLOCA_H 1
 
-/* Define if your compiler conforms to the ANSI C standard. */
+/* Define to 1 if your compiler conforms to the ANSI C standard. */
 #define HAVE_ANSI_COMPILER 1
 
@@ -49,10 +45,6 @@
 /* #undef HAVE_CASE_INSENSITIVE_FS */
 
-/* Define if you have the clock_gettime function. */
+/* Define to 1 if you have the clock_gettime function. */
 /* #undef HAVE_CLOCK_GETTIME */
-
-/* Define if the GNU dcgettext() function is already present or preinstalled.
-   */
-/* #undef HAVE_DCGETTEXT */
 
 /* Define to 1 if you have the declaration of `sys_siglist', and to 0 if you
@@ -108,12 +100,6 @@
 #define HAVE_GETRLIMIT 1
 
-/* Define if the GNU gettext() function is already present or preinstalled. */
-/* #undef HAVE_GETTEXT */
-
-/* Define if you have a standard gettimeofday function */
+/* Define to 1 if you have a standard gettimeofday function */
 #define HAVE_GETTIMEOFDAY 1
-
-/* Define if you have the iconv() function. */
-#define HAVE_ICONV 1
 
 /* Define to 1 if you have the <inttypes.h> header file. */
@@ -138,10 +124,4 @@
 /* #undef HAVE_MACH_MACH_H */
 
-/* Define to 1 if you have the `memcpy' function. */
-#define HAVE_MEMCPY 1
-
-/* Define to 1 if you have the `memmove' function. */
-#define HAVE_MEMMOVE 1
-
 /* Define to 1 if you have the <memory.h> header file. */
 #define HAVE_MEMORY_H 1
@@ -171,5 +151,5 @@
 #define HAVE_REALPATH 1
 
-/* Define if <signal.h> defines the SA_RESTART constant. */
+/* Define to 1 if <signal.h> defines the SA_RESTART constant. */
 #define HAVE_SA_RESTART 1
 
@@ -217,8 +197,8 @@
 
 /* Define to 1 if you have the `strcasecmp' function. */
-/* #undef HAVE_STRCASECMP */
-
-/* Define to 1 if you have the `strchr' function. */
-#define HAVE_STRCHR 1
+#define HAVE_STRCASECMP 1
+
+/* Define to 1 if you have the `strcmpi' function. */
+/* #undef HAVE_STRCMPI */
 
 /* Define to 1 if you have the `strcoll' function and it is properly defined.
@@ -232,4 +212,7 @@
 #define HAVE_STRERROR 1
 
+/* Define to 1 if you have the `stricmp' function. */
+/* #undef HAVE_STRICMP */
+
 /* Define to 1 if you have the <strings.h> header file. */
 #define HAVE_STRINGS_H 1
@@ -273,5 +256,5 @@
 #define HAVE_SYS_WAIT_H 1
 
-/* Define this if you have the \`union wait' type in <sys/wait.h>. */
+/* Define to 1 if you have the \`union wait' type in <sys/wait.h>. */
 /* #undef HAVE_UNION_WAIT */
 
@@ -304,10 +287,10 @@
 
 /* Build host information. */
-#define MAKE_HOST "i386-apple-darwin8.7.3"
-
-/* Define this to enable job server support in GNU make. */
+#define MAKE_HOST "i686-apple-darwin8.8.1"
+
+/* Define to 1 to enable job server support in GNU make. */
 #define MAKE_JOBSERVER 1
 
-/* Define this to enable symbolic link timestamp checking. */
+/* Define to 1 to enable symbolic link timestamp checking. */
 #define MAKE_SYMLINKS 1
 
@@ -316,5 +299,5 @@
 /* #undef NLIST_NAME_UNION */
 
-/* Define if struct nlist.n_name is a pointer rather than an array. */
+/* Define to 1 if struct nlist.n_name is a pointer rather than an array. */
 /* #undef NLIST_STRUCT */
 
@@ -332,5 +315,5 @@
 
 /* Define to the full name and version of this package. */
-#define PACKAGE_STRING "GNU make 3.81"
+#define PACKAGE_STRING "GNU make 3.81.90"
 
 /* Define to the one symbol short name of this package. */
@@ -338,5 +321,8 @@
 
 /* Define to the version of this package. */
-#define PACKAGE_VERSION "3.81"
+#define PACKAGE_VERSION "3.81.90"
+
+/* Define to the character that separates directories in PATH. */
+#define PATH_SEPARATOR_CHAR ':'
 
 /* Define to 1 if the C compiler supports function prototypes. */
@@ -349,5 +335,5 @@
 #define SCCS_GET "get"
 
-/* Define this if the SCCS 'get' command understands the '-G<file>' option. */
+/* Define to 1 if the SCCS 'get' command understands the '-G<file>' option. */
 /* #undef SCCS_GET_MINUS_G */
 
@@ -359,5 +345,5 @@
 /* If using the C implementation of alloca, define if you know the
    direction of stack growth for your system; otherwise it will be
-   automatically deduced at run-time.
+   automatically deduced at runtime.
 	STACK_DIRECTION > 0 => grows toward higher addresses
 	STACK_DIRECTION < 0 => grows toward lower addresses
@@ -388,5 +374,5 @@
 
 /* Version number of package */
-#define VERSION "3.81"
+#define VERSION "3.81.90"
 
 /* Use platform specific coding */
@@ -439,9 +425,2 @@
 /* Define as `fork' if `vfork' does not work. */
 /* #undef vfork */
-
-
-/* bird: added  */
-#define LOCALEDIR   ""
-#define ALIASPATH   ""
-#define LIBDIR      ""
-#define INCLUDEDIR  ""