Index: trunk/src/emx/src/lib/bsd/db/hash/hash_bigkey.c
===================================================================
--- trunk/src/emx/src/lib/bsd/db/hash/hash_bigkey.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/db/hash/hash_bigkey.c	(revision 967)
@@ -35,4 +35,5 @@
  */
 
+#include "libc-alias.h" /*bird*/
 #if defined(LIBC_SCCS) && !defined(lint)
 static char sccsid[] = "@(#)hash_bigkey.c	8.3 (Berkeley) 5/31/94";
Index: trunk/src/emx/src/lib/bsd/db/hash/hash_buf.c
===================================================================
--- trunk/src/emx/src/lib/bsd/db/hash/hash_buf.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/db/hash/hash_buf.c	(revision 967)
@@ -35,4 +35,5 @@
  */
 
+#include "libc-alias.h" /*bird*/
 #if defined(LIBC_SCCS) && !defined(lint)
 static char sccsid[] = "@(#)hash_buf.c	8.5 (Berkeley) 7/15/94";
Index: trunk/src/emx/src/lib/bsd/db/hash/hash_func.c
===================================================================
--- trunk/src/emx/src/lib/bsd/db/hash/hash_func.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/db/hash/hash_func.c	(revision 967)
@@ -35,4 +35,5 @@
  */
 
+#include "libc-alias.h" /*bird*/
 #if defined(LIBC_SCCS) && !defined(lint)
 static char sccsid[] = "@(#)hash_func.c	8.2 (Berkeley) 2/21/94";
Index: trunk/src/emx/src/lib/bsd/db/hash/hash_page.c
===================================================================
--- trunk/src/emx/src/lib/bsd/db/hash/hash_page.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/db/hash/hash_page.c	(revision 967)
@@ -73,4 +73,7 @@
 
 #include <db.h>
+#ifndef __DBINTERFACE_PRIVATE
+#error "__DBINTERFACE_PRIVATE is not defined!"
+#endif
 #include "hash.h"
 #include "page.h"
Index: trunk/src/emx/src/lib/bsd/db/hash/ndbm.c
===================================================================
--- trunk/src/emx/src/lib/bsd/db/hash/ndbm.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/db/hash/ndbm.c	(revision 967)
@@ -35,4 +35,5 @@
  */
 
+#include "libc-alias.h" /*bird*/
 #if defined(LIBC_SCCS) && !defined(lint)
 static char sccsid[] = "@(#)ndbm.c	8.4 (Berkeley) 7/21/94";
Index: trunk/src/emx/src/lib/bsd/stdlib/hcreate.c
===================================================================
--- trunk/src/emx/src/lib/bsd/stdlib/hcreate.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/stdlib/hcreate.c	(revision 967)
@@ -4,5 +4,5 @@
  * Copyright (c) 2001 Christopher G. Demetriou
  * All rights reserved.
- * 
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -20,5 +20,5 @@
  * 4. The name of the author may not be used to endorse or promote products
  *    derived from this software without specific prior written permission.
- * 
+ *
  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
@@ -31,5 +31,5 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- * 
+ *
  * <<Id: LICENSE,v 1.2 2000/06/14 15:57:33 cgd Exp>>
  */
@@ -47,4 +47,5 @@
  */
 
+#include "libc-alias.h"
 #include <sys/cdefs.h>
 #if 0
@@ -89,5 +90,5 @@
 
 int
-hcreate(size_t nel)
+_STD(hcreate)(size_t nel)
 {
 	size_t idx;
@@ -131,5 +132,5 @@
 
 void
-hdestroy(void)
+_STD(hdestroy)(void)
 {
 	struct internal_entry *ie;
@@ -152,5 +153,5 @@
 
 ENTRY *
-hsearch(ENTRY item, ACTION action)
+_STD(hsearch)(ENTRY item, ACTION action)
 {
 	struct internal_head *head;
Index: trunk/src/emx/src/lib/bsd/stdlib/insque.c
===================================================================
--- trunk/src/emx/src/lib/bsd/stdlib/insque.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/stdlib/insque.c	(revision 967)
@@ -5,6 +5,7 @@
  *
  * As long as the above copyright statement and this notice remain
- * unchanged, you can do what ever you want with this file. 
+ * unchanged, you can do what ever you want with this file.
  */
+#include "libc-alias.h"
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD: src/lib/libc/stdlib/insque.c,v 1.3 2003/01/04 07:34:41 tjr Exp $");
@@ -19,5 +20,5 @@
 
 void
-insque(void *element, void *pred)
+_STD(insque)(void *element, void *pred)
 {
 	struct que_elem *prev, *next, *elem;
Index: trunk/src/emx/src/lib/bsd/stdlib/lsearch.c
===================================================================
--- trunk/src/emx/src/lib/bsd/stdlib/lsearch.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/stdlib/lsearch.c	(revision 967)
@@ -5,6 +5,7 @@
  *
  * As long as the above copyright statement and this notice remain
- * unchanged, you can do what ever you want with this file. 
+ * unchanged, you can do what ever you want with this file.
  */
+#include "libc-alias.h"
 #include <sys/types.h>
 #include <sys/cdefs.h>
@@ -20,5 +21,5 @@
     int (*)(const void *, const void *), int);
 
-void *lsearch(const void *key, void *base, size_t *nelp, size_t width,
+void *_STD(lsearch)(const void *key, void *base, size_t *nelp, size_t width,
     int (*compar)(const void *, const void *))
 {
@@ -27,5 +28,5 @@
 }
 
-void *lfind(const void *key, const void *base, size_t *nelp, size_t width,
+void *_STD(lfind)(const void *key, const void *base, size_t *nelp, size_t width,
     int (*compar)(const void *, const void *))
 {
Index: trunk/src/emx/src/lib/bsd/stdlib/remque.c
===================================================================
--- trunk/src/emx/src/lib/bsd/stdlib/remque.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/stdlib/remque.c	(revision 967)
@@ -5,6 +5,7 @@
  *
  * As long as the above copyright statement and this notice remain
- * unchanged, you can do what ever you want with this file. 
+ * unchanged, you can do what ever you want with this file.
  */
+#include "libc-alias.h"
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD: src/lib/libc/stdlib/remque.c,v 1.3 2003/01/04 07:34:41 tjr Exp $");
@@ -15,5 +16,5 @@
 
 void
-remque(void *element)
+_STD(remque)(void *element)
 {
 	struct que_elem *prev, *next, *elem;
Index: trunk/src/emx/src/lib/bsd/stdlib/tdelete.c
===================================================================
--- trunk/src/emx/src/lib/bsd/stdlib/tdelete.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/stdlib/tdelete.c	(revision 967)
@@ -12,4 +12,5 @@
  */
 
+#include "libc-alias.h"
 #include <sys/cdefs.h>
 #if 0
@@ -33,5 +34,5 @@
  */
 void *
-tdelete(const void * __restrict vkey, void ** __restrict vrootp,
+_STD(tdelete)(const void * __restrict vkey, void ** __restrict vrootp,
     int (*compar)(const void *, const void *))
 {
Index: trunk/src/emx/src/lib/bsd/stdlib/tfind.c
===================================================================
--- trunk/src/emx/src/lib/bsd/stdlib/tfind.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/stdlib/tfind.c	(revision 967)
@@ -12,4 +12,5 @@
  */
 
+#include "libc-alias.h"
 #include <sys/cdefs.h>
 #if 0
@@ -26,5 +27,5 @@
 /* find a node, or return 0 */
 void *
-tfind(vkey, vrootp, compar)
+_STD(tfind)(vkey, vrootp, compar)
 	const void *vkey;		/* key to be found */
 	void * const *vrootp;		/* address of the tree root */
Index: trunk/src/emx/src/lib/bsd/stdlib/tsearch.c
===================================================================
--- trunk/src/emx/src/lib/bsd/stdlib/tsearch.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/stdlib/tsearch.c	(revision 967)
@@ -12,4 +12,5 @@
  */
 
+#include "libc-alias.h"
 #include <sys/cdefs.h>
 #if 0
@@ -26,5 +27,5 @@
 /* find or insert datum into search tree */
 void *
-tsearch(vkey, vrootp, compar)
+_STD(tsearch)(vkey, vrootp, compar)
 	const void *vkey;		/* key to be located */
 	void **vrootp;			/* address of tree root */
Index: trunk/src/emx/src/lib/bsd/stdlib/twalk.c
===================================================================
--- trunk/src/emx/src/lib/bsd/stdlib/twalk.c	(revision 966)
+++ trunk/src/emx/src/lib/bsd/stdlib/twalk.c	(revision 967)
@@ -12,4 +12,5 @@
  */
 
+#include "libc-alias.h"
 #include <sys/cdefs.h>
 #if 0
@@ -50,5 +51,5 @@
 /* Walk the nodes of a tree */
 void
-twalk(vroot, action)
+_STD(twalk)(vroot, action)
 	const void *vroot;	/* Root of the tree to be walked */
 	void (*action)(const void *, VISIT, int);